
package de.ivu.elect.business.aufgabe.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.aufgabe.entity.AufgabeKommentar;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractAufgabeKommentarEdit {

  @Inject
  protected AufgabeKommentarDAO dao;

  @Inject
  protected AufgabeKommentarExtendedDAO extendedDao;

  public void delete(AufgabeKommentar entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(AufgabeKommentar entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(AufgabeKommentar entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected AufgabeKommentar getAttachedEntity(AufgabeKommentar entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected AufgabeKommentar getAttachedAndRefreshedEntity(AufgabeKommentar entity) {
    return dao.refresh(entity);
  }
}
